#ifndef __RANKINGTABLE_H_
#define __RANKINGTABLE_H_

class RankingLineT
{
 public:
  RankingLineT (int n_, float PMu_, float MuBest_, float PMuBest_, float R_);
  ~RankingLineT ();
  int n;
  float PMu;
  float MuBest;
  float PMuBest;
  float R;
  RankingLineT *smaller;
  RankingLineT *bigger;
//  RankingLineT *next;
};

class RankingTable
{
 public:
  RankingTable ();
  ~RankingTable ();
  
  int EnterLine (int n, float PMu, float MuBest, float PMuBest, float R);

  void GetN1N2 (int *n1, int *n2, float ConfLevel);

  void Dump ();
  
 private:
  
  RankingLineT *Root;
  int NElements;

  void PrivEnterLine (int n, float PMu,
		      float MuBest, float PMuBest, float R,
		      RankingLineT *&RankingPtr);

  void PrivGetN1N2 (float *AccProb, bool *FirstN, int *n1, int *n2,
		    float ConfLevel, RankingLineT *RankingPtr);

  void  PrivDelete (RankingLineT *&RankingPtr);

  void PrivDump (RankingLineT *RankingPtr);

};

#endif
